Global( "MESSAGE_FADE_IN_TIME", 900 )
Global( "MESSAGE_FADE_SOLID_TIME", 8000 )
Global( "MESSAGE_FADE_OUT_TIME", 2000 )
Global( "WIDGET_FADE_TRANSPARENT", 1 )
Global( "WIDGET_FADE_IN", 2 )
Global( "WIDGET_FADE_SOLID", 3 )
Global( "WIDGET_FADE_OUT", 4 )
Global( "wtMessage", nil )
Global( "fadeStatus", WIDGET_FADE_TRANSPARENT )
Global("onEvent", {})
Global("ids", nil)

function OnEventEffectFinished ( params )
	if params.wtOwner:IsEqual( wtMessage ) then
		if fadeStatus == WIDGET_FADE_IN then
			wtMessage:PlayFadeEffect( 1.0, 1.0, MESSAGE_FADE_SOLID_TIME, EA_MONOTONOUS_INCREASE )
			fadeStatus = WIDGET_FADE_SOLID		
		elseif fadeStatus == WIDGET_FADE_SOLID then
			wtMessage:PlayFadeEffect( 1.0, 0.0, MESSAGE_FADE_OUT_TIME, EA_MONOTONOUS_INCREASE )
			fadeStatus = WIDGET_FADE_OUT		
		elseif fadeStatus == WIDGET_FADE_OUT then
			fadeStatus = WIDGET_FADE_TRANSPARENT
			wtMessage:Show( false )
			common.UnRegisterEventHandler( OnTimer, "EVENT_SECOND_TIMER" )
		end
	end
end

function RegisterEventHandlers( handlers )
	for event, handler in handlers do
		common.RegisterEventHandler( handler, event )
	end
end

onEvent[ "EVENT_UNIT_SPAWNED" ] = function( eventParams )
	if eventParams then
		for id, value in eventParams do
			if value and not unit.IsPlayer(value) and not unit.IsPet(value) and not object.IsDead(value) then
				if unit.GetQuality(value) == 2 then
					ids = value
					wtMessage:SetVal( "value", object.GetName(value) )
					wtMessage:Show( true )
					wtMessage:PlayFadeEffect( 0.0, 1.0, MESSAGE_FADE_IN_TIME, EA_MONOTONOUS_INCREASE )
					fadeStatus = WIDGET_FADE_IN
					common.RegisterEventHandler( OnTimer, "EVENT_SECOND_TIMER" )
				end
			end
		end
	end
end

function OnTimer( params )
  if not avatar.GetTarget() then
	if ids then
		avatar.SelectTarget(ids)
	end
  end
end

onEvent [ "U_EVENT_ADDON_MEM_USAGE_REQUEST" ] = function( params )
    userMods.SendEvent( "U_EVENT_ADDON_MEM_USAGE_RESPONSE", { sender = common.GetAddonName(), memUsage = gcinfo() } )
end

onEvent [ "SCRIPT_TOGGLE_UI" ] = function( params )
    mainForm:Show( params.visible )
end

--------------------------------------------------------------------------------
-- INITIALIZATION
--------------------------------------------------------------------------------
function Init()
	common.RegisterEventHandler( OnEventEffectFinished, "EVENT_EFFECT_FINISHED" )
	wtMessage = mainForm:GetChildChecked( "Announce", false )
	wtMessage:Show( false )
	RegisterEventHandlers( onEvent )
end
--------------------------------------------------------------------------------
Init()
--------------------------------------------------------------------------------
